# generated by datamodel-codegen:
#   filename:  shapefileSource.json
#   timestamp: 2024-09-13T09:04:30+00:00

from __future__ import annotations

from typing import Dict, Optional

from pydantic import BaseModel, ConfigDict, Field


class IShapefileSource(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    path: str = Field(
        ..., description='The path to the shapefile (.shp, .zip, or folder URL).'
    )
    attribution: Optional[str] = Field(
        '', description='The attribution for the shapefile source.'
    )
    projection: Optional[str] = Field(
        'WGS84', description='The projection information for the shapefile (optional).'
    )
    encoding: Optional[str] = Field(
        'UTF-8', description="The encoding used for the shapefile's DBF (optional)."
    )
    additionalFiles: Optional[Dict[str, str]] = Field(
        {},
        description='Additional files associated with the shapefile (e.g., .dbf, .prj, .cpg).',
    )
